/*
 * sieve_err.c:
 * This file is automatically generated; please do not edit it.
 */
#ifdef __STDC__
#define NOARGS void
#else
#define NOARGS
#define const
#endif

#include "sieve_err.h"

static const char * const text[] = {
	"Generic Sieve error",
	"Sieve interpretor not finalized",
	"Parse error in Sieve script",
	"Run-time error during Sieve execution",
	"Internal error in Sieve subsystem",
	"Memory exhausted in Sieve subsystem",
	"Sieve action already taken",
    0
};

struct error_table {
    char const * const * msgs;
    long base;
    int n_msgs;
};

struct et_list {
    struct et_list *next;
    const struct error_table * table;
};

#if defined(__BEOS__) || defined(__HAIKU__)
static struct et_list *_et_list = 0;
#else
extern struct et_list *_et_list;
#endif

static const struct error_table et = { text, -1237848064L, 7 };

static struct et_list link = { 0, 0 };

void initialize_siev_error_table (NOARGS) {
    if (!link.table) {
        link.next = _et_list;
        link.table = &et;
        _et_list = &link;
    }
}

#if defined(__BEOS__) || defined(__HAIKU__)
const char* sieve_strerror( long err_no) {
	long offs;
	const struct error_table* table;
	initialize_siev_error_table();
	table = link.table;
	if (table) {
		offs = err_no-table->base;
		if (offs>=0 && offs<table->n_msgs)
			return table->msgs[offs];
	}
	return "unknown error (libsieve)";
}
#endif
